package ru.cft.task.restClient;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import org.springframework.http.*;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class RestActionsController {
    @FXML
    private TextField id;

    @FXML
    private TextField name;

    @FXML
    private TextField email;

    @FXML
    private Button cancel;

    private String getRestServerUrl() {
        Properties props = new Properties();
        InputStream conf_file = null;
        String url = "";
        try {
            conf_file = new FileInputStream(ConfigController.getConfigFile());
            props.load(conf_file);
            url = props.getProperty("url", "http://localhost");
            url += ":" + props.getProperty("port", "8080");
        } catch (IOException ex) {
            Utils.showAlert("error", ex.getMessage());
        } finally {
            if (conf_file != null) {
                try {
                    conf_file.close();
                } catch (IOException ex) {
                    Utils.showAlert("error", ex.getMessage());
                }
            }
            return url;
        }
    }

    public void cancelAction() {
        Stage stage = (Stage) cancel.getScene().getWindow();
        stage.close();
    }

    public void createAction() {
        EmailRecord emailRecord = new EmailRecord();
        emailRecord.setName("Test");
        emailRecord.setEmail("aaa");

        RestTemplate restTemplate = new RestTemplate();
        HttpEntity<EmailRecord> request = new HttpEntity<>(emailRecord);
        try {
            ResponseEntity<EmailRecord> response = restTemplate.exchange(getRestServerUrl(), HttpMethod.POST, request, EmailRecord.class);
            System.out.println(response.getStatusCode());
            if (response.getStatusCode() == HttpStatus.OK) {
                EmailRecord er = response.getBody();
                id.setText(String.valueOf(er.getId()));
            }
        } catch (RestClientException ex) {
            Utils.showAlert("error", ex.getMessage());
        }
    }

    public void readAction() {
        HttpHeaders headers = new HttpHeaders();
        headers.add("Accept", MediaType.APPLICATION_JSON_VALUE);
        headers.setContentType(MediaType.APPLICATION_JSON);
        headers.set("id", id.getText());
        headers.set("name", name.getText());
        headers.set("email", email.getText());

        RestTemplate restTemplate = new RestTemplate();
        HttpEntity<EmailRecord> entity = new HttpEntity<>(headers);
        try {
            ResponseEntity<EmailRecord> result = restTemplate.exchange(getRestServerUrl(), HttpMethod.GET, entity, EmailRecord.class);
            if (result.getStatusCode() == HttpStatus.OK) {
                EmailRecord emailRecord = result.getBody();
                id.setText(String.valueOf(emailRecord.getId()));
                name.setText(emailRecord.getName());
                email.setText(emailRecord.getEmail());
            }
        } catch (RestClientException ex) {
            Utils.showAlert("error", ex.getMessage());
        }
    }

    public void updateAction() {

    }

    public void deleteAction() {

    }
}
